/* protocol-scope-interface.c generated by valac 0.17.2, the Vala compiler
 * generated from protocol-scope-interface.vala, do not modify */

/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define UNITY_PROTOCOL_TYPE_SCOPE_INFO (unity_protocol_scope_info_get_type ())
typedef struct _UnityProtocolScopeInfo UnityProtocolScopeInfo;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define UNITY_PROTOCOL_TYPE_ACTIVATION_REPLY_RAW (unity_protocol_activation_reply_raw_get_type ())
typedef struct _UnityProtocolActivationReplyRaw UnityProtocolActivationReplyRaw;

#define UNITY_PROTOCOL_TYPE_SCOPE_SERVICE (unity_protocol_scope_service_get_type ())
#define UNITY_PROTOCOL_SCOPE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, UnityProtocolScopeService))
#define UNITY_PROTOCOL_IS_SCOPE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE))
#define UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, UnityProtocolScopeServiceIface))

typedef struct _UnityProtocolScopeService UnityProtocolScopeService;
typedef struct _UnityProtocolScopeServiceIface UnityProtocolScopeServiceIface;

#define UNITY_PROTOCOL_TYPE_SCOPE_SERVICE_PROXY (unity_protocol_scope_service_proxy_get_type ())
typedef GDBusProxy UnityProtocolScopeServiceProxy;
typedef GDBusProxyClass UnityProtocolScopeServiceProxyClass;

struct _UnityProtocolScopeInfo {
	gchar* dbus_path;
	GVariant* sources;
	gboolean search_in_global;
	gchar* private_connection_name;
	gchar* results_model_name;
	gchar* global_results_model_name;
	gchar* filters_model_name;
	GHashTable* hints;
};

struct _UnityProtocolActivationReplyRaw {
	gchar* uri;
	guint handled;
	GHashTable* hints;
};

typedef enum  {
	UNITY_PROTOCOL_SCOPE_ERROR_SEARCH_CANCELLED,
	UNITY_PROTOCOL_SCOPE_ERROR_UNKNOWN
} UnityProtocolScopeError;
#define UNITY_PROTOCOL_SCOPE_ERROR unity_protocol_scope_error_quark ()
struct _UnityProtocolScopeServiceIface {
	GTypeInterface parent_iface;
	void (*info_request) (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*info_request_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*activate) (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
	void (*update_preview_property) (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*update_preview_property_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*search) (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*search_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*global_search) (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*global_search_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*set_view_type) (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_view_type_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*set_active_sources) (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_active_sources_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
};



GType unity_protocol_scope_info_get_type (void) G_GNUC_CONST;
UnityProtocolScopeInfo* unity_protocol_scope_info_dup (const UnityProtocolScopeInfo* self);
void unity_protocol_scope_info_free (UnityProtocolScopeInfo* self);
void unity_protocol_scope_info_copy (const UnityProtocolScopeInfo* self, UnityProtocolScopeInfo* dest);
void unity_protocol_scope_info_destroy (UnityProtocolScopeInfo* self);
GType unity_protocol_activation_reply_raw_get_type (void) G_GNUC_CONST;
UnityProtocolActivationReplyRaw* unity_protocol_activation_reply_raw_dup (const UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_free (UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_copy (const UnityProtocolActivationReplyRaw* self, UnityProtocolActivationReplyRaw* dest);
void unity_protocol_activation_reply_raw_destroy (UnityProtocolActivationReplyRaw* self);
GQuark unity_protocol_scope_error_quark (void);
GType unity_protocol_scope_service_proxy_get_type (void) G_GNUC_CONST;
guint unity_protocol_scope_service_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType unity_protocol_scope_service_get_type (void) G_GNUC_CONST;
void unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_activate (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
void unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void unity_protocol_scope_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_unity_protocol_scope_service_changed (UnityProtocolScopeService* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void unity_protocol_scope_service_proxy_info_request_async (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_activate_async (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
static void unity_protocol_scope_service_proxy_update_preview_property_async (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_global_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_set_view_type_async (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_set_active_sources_async (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init (UnityProtocolScopeServiceIface* iface);
static void _dbus_unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_activate (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_set_active_sources_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void unity_protocol_scope_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* unity_protocol_scope_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean unity_protocol_scope_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_unity_protocol_scope_service_changed (GObject* _sender, UnityProtocolScopeInfo* lens_info, gpointer* _data);
static void _unity_protocol_scope_service_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusErrorEntry unity_protocol_scope_error_entries[] = {{UNITY_PROTOCOL_SCOPE_ERROR_SEARCH_CANCELLED, "com.canonical.Unity.ScopeError.SearchCancelled"}, {UNITY_PROTOCOL_SCOPE_ERROR_UNKNOWN, "com.canonical.Unity.ScopeError.Unknown"}};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_info_request_in[] = {NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_info_request_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_info_request = {-1, "InfoRequest", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_info_request_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_info_request_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_action_type = {-1, "action_type", "u"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_result = {-1, "result", "(sua{sv})"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_activate_in[] = {&_unity_protocol_scope_service_dbus_arg_info_activate_uri, &_unity_protocol_scope_service_dbus_arg_info_activate_action_type, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_activate_out[] = {&_unity_protocol_scope_service_dbus_arg_info_activate_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_activate = {-1, "Activate", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_activate_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_activate_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_values = {-1, "values", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_update_preview_property_in[] = {&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_uri, &_unity_protocol_scope_service_dbus_arg_info_update_preview_property_values, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_update_preview_property_out[] = {&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_update_preview_property = {-1, "UpdatePreviewProperty", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_search_in[] = {&_unity_protocol_scope_service_dbus_arg_info_search_search_string, &_unity_protocol_scope_service_dbus_arg_info_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_search_out[] = {&_unity_protocol_scope_service_dbus_arg_info_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_search = {-1, "Search", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_search_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_search_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_global_search_in[] = {&_unity_protocol_scope_service_dbus_arg_info_global_search_search_string, &_unity_protocol_scope_service_dbus_arg_info_global_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_global_search_out[] = {&_unity_protocol_scope_service_dbus_arg_info_global_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_global_search = {-1, "GlobalSearch", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_global_search_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_global_search_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_set_view_type_view_type = {-1, "view_type", "u"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_view_type_in[] = {&_unity_protocol_scope_service_dbus_arg_info_set_view_type_view_type, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_view_type_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_set_view_type = {-1, "SetViewType", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_view_type_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_view_type_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_set_active_sources_sources = {-1, "sources", "as"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_active_sources_in[] = {&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_sources, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_active_sources_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_set_active_sources = {-1, "SetActiveSources", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_out)};
static const GDBusMethodInfo * const _unity_protocol_scope_service_dbus_method_info[] = {&_unity_protocol_scope_service_dbus_method_info_info_request, &_unity_protocol_scope_service_dbus_method_info_activate, &_unity_protocol_scope_service_dbus_method_info_update_preview_property, &_unity_protocol_scope_service_dbus_method_info_search, &_unity_protocol_scope_service_dbus_method_info_global_search, &_unity_protocol_scope_service_dbus_method_info_set_view_type, &_unity_protocol_scope_service_dbus_method_info_set_active_sources, NULL};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_changed_lens_info = {-1, "lens_info", "(svbssssa{sv})"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_changed[] = {&_unity_protocol_scope_service_dbus_arg_info_changed_lens_info, NULL};
static const GDBusSignalInfo _unity_protocol_scope_service_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_changed)};
static const GDBusSignalInfo * const _unity_protocol_scope_service_dbus_signal_info[] = {&_unity_protocol_scope_service_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo * const _unity_protocol_scope_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _unity_protocol_scope_service_dbus_interface_info = {-1, "com.canonical.Unity.Scope", (GDBusMethodInfo **) (&_unity_protocol_scope_service_dbus_method_info), (GDBusSignalInfo **) (&_unity_protocol_scope_service_dbus_signal_info), (GDBusPropertyInfo **) (&_unity_protocol_scope_service_dbus_property_info)};
static const GDBusInterfaceVTable _unity_protocol_scope_service_dbus_interface_vtable = {unity_protocol_scope_service_dbus_interface_method_call, unity_protocol_scope_service_dbus_interface_get_property, unity_protocol_scope_service_dbus_interface_set_property};

static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


void unity_protocol_scope_info_copy (const UnityProtocolScopeInfo* self, UnityProtocolScopeInfo* dest) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GHashTable* _tmp13_;
	GHashTable* _tmp14_;
	_tmp0_ = (*self).dbus_path;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).dbus_path);
	(*dest).dbus_path = _tmp1_;
	_tmp2_ = (*self).sources;
	_tmp3_ = _g_variant_ref0 (_tmp2_);
	_g_variant_unref0 ((*dest).sources);
	(*dest).sources = _tmp3_;
	_tmp4_ = (*self).search_in_global;
	(*dest).search_in_global = _tmp4_;
	_tmp5_ = (*self).private_connection_name;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*dest).private_connection_name);
	(*dest).private_connection_name = _tmp6_;
	_tmp7_ = (*self).results_model_name;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 ((*dest).results_model_name);
	(*dest).results_model_name = _tmp8_;
	_tmp9_ = (*self).global_results_model_name;
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 ((*dest).global_results_model_name);
	(*dest).global_results_model_name = _tmp10_;
	_tmp11_ = (*self).filters_model_name;
	_tmp12_ = g_strdup (_tmp11_);
	_g_free0 ((*dest).filters_model_name);
	(*dest).filters_model_name = _tmp12_;
	_tmp13_ = (*self).hints;
	_tmp14_ = _g_hash_table_ref0 (_tmp13_);
	_g_hash_table_unref0 ((*dest).hints);
	(*dest).hints = _tmp14_;
}


void unity_protocol_scope_info_destroy (UnityProtocolScopeInfo* self) {
	_g_free0 ((*self).dbus_path);
	_g_variant_unref0 ((*self).sources);
	_g_free0 ((*self).private_connection_name);
	_g_free0 ((*self).results_model_name);
	_g_free0 ((*self).global_results_model_name);
	_g_free0 ((*self).filters_model_name);
	_g_hash_table_unref0 ((*self).hints);
}


UnityProtocolScopeInfo* unity_protocol_scope_info_dup (const UnityProtocolScopeInfo* self) {
	UnityProtocolScopeInfo* dup;
	dup = g_new0 (UnityProtocolScopeInfo, 1);
	unity_protocol_scope_info_copy (self, dup);
	return dup;
}


void unity_protocol_scope_info_free (UnityProtocolScopeInfo* self) {
	unity_protocol_scope_info_destroy (self);
	g_free (self);
}


GType unity_protocol_scope_info_get_type (void) {
	static volatile gsize unity_protocol_scope_info_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_scope_info_type_id__volatile)) {
		GType unity_protocol_scope_info_type_id;
		unity_protocol_scope_info_type_id = g_boxed_type_register_static ("UnityProtocolScopeInfo", (GBoxedCopyFunc) unity_protocol_scope_info_dup, (GBoxedFreeFunc) unity_protocol_scope_info_free);
		g_once_init_leave (&unity_protocol_scope_info_type_id__volatile, unity_protocol_scope_info_type_id);
	}
	return unity_protocol_scope_info_type_id__volatile;
}


void unity_protocol_activation_reply_raw_copy (const UnityProtocolActivationReplyRaw* self, UnityProtocolActivationReplyRaw* dest) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	_tmp0_ = (*self).uri;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).uri);
	(*dest).uri = _tmp1_;
	_tmp2_ = (*self).handled;
	(*dest).handled = _tmp2_;
	_tmp3_ = (*self).hints;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 ((*dest).hints);
	(*dest).hints = _tmp4_;
}


void unity_protocol_activation_reply_raw_destroy (UnityProtocolActivationReplyRaw* self) {
	_g_free0 ((*self).uri);
	_g_hash_table_unref0 ((*self).hints);
}


UnityProtocolActivationReplyRaw* unity_protocol_activation_reply_raw_dup (const UnityProtocolActivationReplyRaw* self) {
	UnityProtocolActivationReplyRaw* dup;
	dup = g_new0 (UnityProtocolActivationReplyRaw, 1);
	unity_protocol_activation_reply_raw_copy (self, dup);
	return dup;
}


void unity_protocol_activation_reply_raw_free (UnityProtocolActivationReplyRaw* self) {
	unity_protocol_activation_reply_raw_destroy (self);
	g_free (self);
}


GType unity_protocol_activation_reply_raw_get_type (void) {
	static volatile gsize unity_protocol_activation_reply_raw_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_activation_reply_raw_type_id__volatile)) {
		GType unity_protocol_activation_reply_raw_type_id;
		unity_protocol_activation_reply_raw_type_id = g_boxed_type_register_static ("UnityProtocolActivationReplyRaw", (GBoxedCopyFunc) unity_protocol_activation_reply_raw_dup, (GBoxedFreeFunc) unity_protocol_activation_reply_raw_free);
		g_once_init_leave (&unity_protocol_activation_reply_raw_type_id__volatile, unity_protocol_activation_reply_raw_type_id);
	}
	return unity_protocol_activation_reply_raw_type_id__volatile;
}


GQuark unity_protocol_scope_error_quark (void) {
	static volatile gsize unity_protocol_scope_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("unity_protocol_scope_error-quark", &unity_protocol_scope_error_quark_volatile, unity_protocol_scope_error_entries, G_N_ELEMENTS (unity_protocol_scope_error_entries));
	return (GQuark) unity_protocol_scope_error_quark_volatile;
}


void unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->info_request (self, _callback_, _user_data_);
}


void unity_protocol_scope_service_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->info_request_finish (self, _res_, error);
}


void unity_protocol_scope_service_activate (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->activate (self, uri, action_type, _callback_, _user_data_);
}


void unity_protocol_scope_service_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->activate_finish (self, _res_, result, error);
}


void unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->update_preview_property (self, uri, values, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->update_preview_property_finish (self, _res_, error);
}


void unity_protocol_scope_service_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->search_finish (self, _res_, error);
}


void unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->global_search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->global_search_finish (self, _res_, error);
}


void unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_view_type (self, view_type, _callback_, _user_data_);
}


void unity_protocol_scope_service_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_view_type_finish (self, _res_, error);
}


void unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_active_sources (self, sources, sources_length1, _callback_, _user_data_);
}


void unity_protocol_scope_service_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_active_sources_finish (self, _res_, error);
}


static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), data2);
}


static void unity_protocol_scope_service_base_init (UnityProtocolScopeServiceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("changed", UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, UNITY_PROTOCOL_TYPE_SCOPE_INFO);
	}
}


/**
 * ScopeService:
 *
 * The Scope interface exported on DBus
 */
GType unity_protocol_scope_service_get_type (void) {
	static volatile gsize unity_protocol_scope_service_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_scope_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityProtocolScopeServiceIface), (GBaseInitFunc) unity_protocol_scope_service_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_protocol_scope_service_type_id;
		unity_protocol_scope_service_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityProtocolScopeService", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_protocol_scope_service_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) unity_protocol_scope_service_proxy_get_type);
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.canonical.Unity.Scope");
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) unity_protocol_scope_service_register_object);
		g_once_init_leave (&unity_protocol_scope_service_type_id__volatile, unity_protocol_scope_service_type_id);
	}
	return unity_protocol_scope_service_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (UnityProtocolScopeServiceProxy, unity_protocol_scope_service_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init) )
static void unity_protocol_scope_service_proxy_class_init (UnityProtocolScopeServiceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = unity_protocol_scope_service_proxy_g_signal;
}


static void _dbus_handle_unity_protocol_scope_service_changed (UnityProtocolScopeService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	UnityProtocolScopeInfo lens_info = {0};
	GVariant* _tmp107_;
	UnityProtocolScopeInfo _tmp108_;
	GVariantIter _tmp109_;
	GVariant* _tmp110_;
	GVariant* _tmp111_;
	GVariant* _tmp112_;
	GVariant* _tmp113_;
	GVariant* _tmp114_;
	GVariant* _tmp115_;
	GVariant* _tmp116_;
	GVariant* _tmp117_;
	GHashTable* _tmp118_;
	GVariantIter _tmp119_;
	GVariant* _tmp120_;
	GVariant* _tmp121_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp107_ = g_variant_iter_next_value (&_arguments_iter);
	g_variant_iter_init (&_tmp109_, _tmp107_);
	_tmp110_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.dbus_path = g_variant_dup_string (_tmp110_, NULL);
	g_variant_unref (_tmp110_);
	_tmp111_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.sources = g_variant_get_variant (_tmp111_);
	g_variant_unref (_tmp111_);
	_tmp112_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.search_in_global = g_variant_get_boolean (_tmp112_);
	g_variant_unref (_tmp112_);
	_tmp113_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.private_connection_name = g_variant_dup_string (_tmp113_, NULL);
	g_variant_unref (_tmp113_);
	_tmp114_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.results_model_name = g_variant_dup_string (_tmp114_, NULL);
	g_variant_unref (_tmp114_);
	_tmp115_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.global_results_model_name = g_variant_dup_string (_tmp115_, NULL);
	g_variant_unref (_tmp115_);
	_tmp116_ = g_variant_iter_next_value (&_tmp109_);
	_tmp108_.filters_model_name = g_variant_dup_string (_tmp116_, NULL);
	g_variant_unref (_tmp116_);
	_tmp117_ = g_variant_iter_next_value (&_tmp109_);
	_tmp118_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp119_, _tmp117_);
	while (g_variant_iter_loop (&_tmp119_, "{?*}", &_tmp120_, &_tmp121_)) {
		g_hash_table_insert (_tmp118_, g_variant_dup_string (_tmp120_, NULL), g_variant_get_variant (_tmp121_));
	}
	_tmp108_.hints = _tmp118_;
	g_variant_unref (_tmp117_);
	lens_info = _tmp108_;
	g_variant_unref (_tmp107_);
	g_signal_emit_by_name (self, "changed", &lens_info);
	unity_protocol_scope_info_destroy (&lens_info);
}


static void unity_protocol_scope_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_unity_protocol_scope_service_changed ((UnityProtocolScopeService*) proxy, parameters);
	}
}


static void unity_protocol_scope_service_proxy_init (UnityProtocolScopeServiceProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void unity_protocol_scope_service_proxy_info_request_async (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "InfoRequest");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_activate_async (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "Activate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action_type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GVariant* _tmp122_;
	UnityProtocolActivationReplyRaw _tmp123_;
	GVariantIter _tmp124_;
	GVariant* _tmp125_;
	GVariant* _tmp126_;
	GVariant* _tmp127_;
	GHashTable* _tmp128_;
	GVariantIter _tmp129_;
	GVariant* _tmp130_;
	GVariant* _tmp131_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp122_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp124_, _tmp122_);
	_tmp125_ = g_variant_iter_next_value (&_tmp124_);
	_tmp123_.uri = g_variant_dup_string (_tmp125_, NULL);
	g_variant_unref (_tmp125_);
	_tmp126_ = g_variant_iter_next_value (&_tmp124_);
	_tmp123_.handled = g_variant_get_uint32 (_tmp126_);
	g_variant_unref (_tmp126_);
	_tmp127_ = g_variant_iter_next_value (&_tmp124_);
	_tmp128_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp129_, _tmp127_);
	while (g_variant_iter_loop (&_tmp129_, "{?*}", &_tmp130_, &_tmp131_)) {
		g_hash_table_insert (_tmp128_, g_variant_dup_string (_tmp130_, NULL), g_variant_get_variant (_tmp131_));
	}
	_tmp123_.hints = _tmp128_;
	g_variant_unref (_tmp127_);
	*result = _tmp123_;
	g_variant_unref (_tmp122_);
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_update_preview_property_async (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp132_;
	GHashTableIter _tmp133_;
	gpointer _tmp134_;
	gpointer _tmp135_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "UpdatePreviewProperty");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_hash_table_iter_init (&_tmp133_, values);
	g_variant_builder_init (&_tmp132_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp133_, &_tmp134_, &_tmp135_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp134_;
		_value = (GVariant*) _tmp135_;
		g_variant_builder_add (&_tmp132_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp132_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp136_;
	GHashTable* _tmp137_;
	GVariantIter _tmp138_;
	GVariant* _tmp139_;
	GVariant* _tmp140_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp136_ = g_variant_iter_next_value (&_reply_iter);
	_tmp137_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp138_, _tmp136_);
	while (g_variant_iter_loop (&_tmp138_, "{?*}", &_tmp139_, &_tmp140_)) {
		g_hash_table_insert (_tmp137_, g_variant_dup_string (_tmp139_, NULL), g_variant_get_variant (_tmp140_));
	}
	_result = _tmp137_;
	g_variant_unref (_tmp136_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp141_;
	GHashTableIter _tmp142_;
	gpointer _tmp143_;
	gpointer _tmp144_;
	G_IO_ERROR;
	UNITY_PROTOCOL_SCOPE_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "Search");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp142_, hints);
	g_variant_builder_init (&_tmp141_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp142_, &_tmp143_, &_tmp144_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp143_;
		_value = (GVariant*) _tmp144_;
		g_variant_builder_add (&_tmp141_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp141_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp145_;
	GHashTable* _tmp146_;
	GVariantIter _tmp147_;
	GVariant* _tmp148_;
	GVariant* _tmp149_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp145_ = g_variant_iter_next_value (&_reply_iter);
	_tmp146_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp147_, _tmp145_);
	while (g_variant_iter_loop (&_tmp147_, "{?*}", &_tmp148_, &_tmp149_)) {
		g_hash_table_insert (_tmp146_, g_variant_dup_string (_tmp148_, NULL), g_variant_get_variant (_tmp149_));
	}
	_result = _tmp146_;
	g_variant_unref (_tmp145_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_global_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp150_;
	GHashTableIter _tmp151_;
	gpointer _tmp152_;
	gpointer _tmp153_;
	G_IO_ERROR;
	UNITY_PROTOCOL_SCOPE_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "GlobalSearch");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp151_, hints);
	g_variant_builder_init (&_tmp150_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp151_, &_tmp152_, &_tmp153_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp152_;
		_value = (GVariant*) _tmp153_;
		g_variant_builder_add (&_tmp150_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp150_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp154_;
	GHashTable* _tmp155_;
	GVariantIter _tmp156_;
	GVariant* _tmp157_;
	GVariant* _tmp158_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp154_ = g_variant_iter_next_value (&_reply_iter);
	_tmp155_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp156_, _tmp154_);
	while (g_variant_iter_loop (&_tmp156_, "{?*}", &_tmp157_, &_tmp158_)) {
		g_hash_table_insert (_tmp155_, g_variant_dup_string (_tmp157_, NULL), g_variant_get_variant (_tmp158_));
	}
	_result = _tmp155_;
	g_variant_unref (_tmp154_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_set_view_type_async (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "SetViewType");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (view_type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_set_active_sources_async (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp159_;
	GVariantBuilder _tmp160_;
	int _tmp161_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "SetActiveSources");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp159_ = sources;
	g_variant_builder_init (&_tmp160_, G_VARIANT_TYPE ("as"));
	for (_tmp161_ = 0; _tmp161_ < sources_length1; _tmp161_++) {
		g_variant_builder_add_value (&_tmp160_, g_variant_new_string (*_tmp159_));
		_tmp159_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp160_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init (UnityProtocolScopeServiceIface* iface) {
	iface->info_request = unity_protocol_scope_service_proxy_info_request_async;
	iface->info_request_finish = unity_protocol_scope_service_proxy_info_request_finish;
	iface->activate = unity_protocol_scope_service_proxy_activate_async;
	iface->activate_finish = unity_protocol_scope_service_proxy_activate_finish;
	iface->update_preview_property = unity_protocol_scope_service_proxy_update_preview_property_async;
	iface->update_preview_property_finish = unity_protocol_scope_service_proxy_update_preview_property_finish;
	iface->search = unity_protocol_scope_service_proxy_search_async;
	iface->search_finish = unity_protocol_scope_service_proxy_search_finish;
	iface->global_search = unity_protocol_scope_service_proxy_global_search_async;
	iface->global_search_finish = unity_protocol_scope_service_proxy_global_search_finish;
	iface->set_view_type = unity_protocol_scope_service_proxy_set_view_type_async;
	iface->set_view_type_finish = unity_protocol_scope_service_proxy_set_view_type_finish;
	iface->set_active_sources = unity_protocol_scope_service_proxy_set_active_sources_async;
	iface->set_active_sources_finish = unity_protocol_scope_service_proxy_set_active_sources_finish;
}


static void _dbus_unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	unity_protocol_scope_service_info_request (self, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_info_request_ready, invocation);
}


static void _dbus_unity_protocol_scope_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_info_request_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_activate (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp162_;
	guint action_type = 0U;
	GVariant* _tmp163_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp162_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp162_, NULL);
	g_variant_unref (_tmp162_);
	_tmp163_ = g_variant_iter_next_value (&_arguments_iter);
	action_type = g_variant_get_uint32 (_tmp163_);
	g_variant_unref (_tmp163_);
	unity_protocol_scope_service_activate (self, uri, action_type, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_activate_ready, invocation);
	_g_free0 (uri);
}


static void _dbus_unity_protocol_scope_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	UnityProtocolActivationReplyRaw result = {0};
	GVariantBuilder _tmp164_;
	GVariantBuilder _tmp165_;
	GHashTableIter _tmp166_;
	gpointer _tmp167_;
	gpointer _tmp168_;
	invocation = _user_data_;
	unity_protocol_scope_service_activate_finish ((UnityProtocolScopeService*) source_object, _res_, &result, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp164_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp164_, g_variant_new_string (result.uri));
	g_variant_builder_add_value (&_tmp164_, g_variant_new_uint32 (result.handled));
	g_hash_table_iter_init (&_tmp166_, result.hints);
	g_variant_builder_init (&_tmp165_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp166_, &_tmp167_, &_tmp168_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp167_;
		_value = (GVariant*) _tmp168_;
		g_variant_builder_add (&_tmp165_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp164_, g_variant_builder_end (&_tmp165_));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp164_));
	unity_protocol_activation_reply_raw_destroy (&result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp169_;
	GHashTable* values = NULL;
	GVariant* _tmp170_;
	GHashTable* _tmp171_;
	GVariantIter _tmp172_;
	GVariant* _tmp173_;
	GVariant* _tmp174_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp169_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp169_, NULL);
	g_variant_unref (_tmp169_);
	_tmp170_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp171_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp172_, _tmp170_);
	while (g_variant_iter_loop (&_tmp172_, "{?*}", &_tmp173_, &_tmp174_)) {
		g_hash_table_insert (_tmp171_, g_variant_dup_string (_tmp173_, NULL), g_variant_get_variant (_tmp174_));
	}
	values = _tmp171_;
	g_variant_unref (_tmp170_);
	unity_protocol_scope_service_update_preview_property (self, uri, values, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_update_preview_property_ready, invocation);
	_g_free0 (uri);
	_g_hash_table_unref0 (values);
}


static void _dbus_unity_protocol_scope_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp175_;
	GHashTableIter _tmp176_;
	gpointer _tmp177_;
	gpointer _tmp178_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_update_preview_property_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp176_, result);
	g_variant_builder_init (&_tmp175_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp176_, &_tmp177_, &_tmp178_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp177_;
		_value = (GVariant*) _tmp178_;
		g_variant_builder_add (&_tmp175_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp175_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp179_;
	GHashTable* hints = NULL;
	GVariant* _tmp180_;
	GHashTable* _tmp181_;
	GVariantIter _tmp182_;
	GVariant* _tmp183_;
	GVariant* _tmp184_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp179_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp179_, NULL);
	g_variant_unref (_tmp179_);
	_tmp180_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp181_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp182_, _tmp180_);
	while (g_variant_iter_loop (&_tmp182_, "{?*}", &_tmp183_, &_tmp184_)) {
		g_hash_table_insert (_tmp181_, g_variant_dup_string (_tmp183_, NULL), g_variant_get_variant (_tmp184_));
	}
	hints = _tmp181_;
	g_variant_unref (_tmp180_);
	unity_protocol_scope_service_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_scope_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp185_;
	GHashTableIter _tmp186_;
	gpointer _tmp187_;
	gpointer _tmp188_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_search_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp186_, result);
	g_variant_builder_init (&_tmp185_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp186_, &_tmp187_, &_tmp188_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp187_;
		_value = (GVariant*) _tmp188_;
		g_variant_builder_add (&_tmp185_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp185_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp189_;
	GHashTable* hints = NULL;
	GVariant* _tmp190_;
	GHashTable* _tmp191_;
	GVariantIter _tmp192_;
	GVariant* _tmp193_;
	GVariant* _tmp194_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp189_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp189_, NULL);
	g_variant_unref (_tmp189_);
	_tmp190_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp191_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp192_, _tmp190_);
	while (g_variant_iter_loop (&_tmp192_, "{?*}", &_tmp193_, &_tmp194_)) {
		g_hash_table_insert (_tmp191_, g_variant_dup_string (_tmp193_, NULL), g_variant_get_variant (_tmp194_));
	}
	hints = _tmp191_;
	g_variant_unref (_tmp190_);
	unity_protocol_scope_service_global_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_global_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_scope_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp195_;
	GHashTableIter _tmp196_;
	gpointer _tmp197_;
	gpointer _tmp198_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_global_search_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp196_, result);
	g_variant_builder_init (&_tmp195_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp196_, &_tmp197_, &_tmp198_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp197_;
		_value = (GVariant*) _tmp198_;
		g_variant_builder_add (&_tmp195_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp195_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	guint view_type = 0U;
	GVariant* _tmp199_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp199_ = g_variant_iter_next_value (&_arguments_iter);
	view_type = g_variant_get_uint32 (_tmp199_);
	g_variant_unref (_tmp199_);
	unity_protocol_scope_service_set_view_type (self, view_type, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_set_view_type_ready, invocation);
}


static void _dbus_unity_protocol_scope_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_set_view_type_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar** sources = NULL;
	int sources_length1 = 0;
	GVariant* _tmp200_;
	gchar** _tmp201_;
	int _tmp201__length;
	int _tmp201__size;
	int _tmp201__length1;
	GVariantIter _tmp202_;
	GVariant* _tmp203_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp200_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp201_ = g_new (gchar*, 5);
	_tmp201__length = 0;
	_tmp201__size = 4;
	_tmp201__length1 = 0;
	g_variant_iter_init (&_tmp202_, _tmp200_);
	for (; (_tmp203_ = g_variant_iter_next_value (&_tmp202_)) != NULL; _tmp201__length1++) {
		if (_tmp201__size == _tmp201__length) {
			_tmp201__size = 2 * _tmp201__size;
			_tmp201_ = g_renew (gchar*, _tmp201_, _tmp201__size + 1);
		}
		_tmp201_[_tmp201__length++] = g_variant_dup_string (_tmp203_, NULL);
		g_variant_unref (_tmp203_);
	}
	sources_length1 = _tmp201__length1;
	_tmp201_[_tmp201__length] = NULL;
	sources = _tmp201_;
	g_variant_unref (_tmp200_);
	unity_protocol_scope_service_set_active_sources (self, sources, sources_length1, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_set_active_sources_ready, invocation);
	sources = (_vala_array_free (sources, sources_length1, (GDestroyNotify) g_free), NULL);
}


static void _dbus_unity_protocol_scope_service_set_active_sources_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_set_active_sources_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "InfoRequest") == 0) {
		_dbus_unity_protocol_scope_service_info_request (object, parameters, invocation);
	} else if (strcmp (method_name, "Activate") == 0) {
		_dbus_unity_protocol_scope_service_activate (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdatePreviewProperty") == 0) {
		_dbus_unity_protocol_scope_service_update_preview_property (object, parameters, invocation);
	} else if (strcmp (method_name, "Search") == 0) {
		_dbus_unity_protocol_scope_service_search (object, parameters, invocation);
	} else if (strcmp (method_name, "GlobalSearch") == 0) {
		_dbus_unity_protocol_scope_service_global_search (object, parameters, invocation);
	} else if (strcmp (method_name, "SetViewType") == 0) {
		_dbus_unity_protocol_scope_service_set_view_type (object, parameters, invocation);
	} else if (strcmp (method_name, "SetActiveSources") == 0) {
		_dbus_unity_protocol_scope_service_set_active_sources (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* unity_protocol_scope_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean unity_protocol_scope_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_unity_protocol_scope_service_changed (GObject* _sender, UnityProtocolScopeInfo* lens_info, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp204_;
	GVariantBuilder _tmp205_;
	GHashTableIter _tmp206_;
	gpointer _tmp207_;
	gpointer _tmp208_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp204_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string ((*lens_info).dbus_path));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_variant ((*lens_info).sources));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_boolean ((*lens_info).search_in_global));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string ((*lens_info).private_connection_name));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string ((*lens_info).results_model_name));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string ((*lens_info).global_results_model_name));
	g_variant_builder_add_value (&_tmp204_, g_variant_new_string ((*lens_info).filters_model_name));
	g_hash_table_iter_init (&_tmp206_, (*lens_info).hints);
	g_variant_builder_init (&_tmp205_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp206_, &_tmp207_, &_tmp208_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp207_;
		_value = (GVariant*) _tmp208_;
		g_variant_builder_add (&_tmp205_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp204_, g_variant_builder_end (&_tmp205_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp204_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.Unity.Scope", "Changed", _arguments, NULL);
}


guint unity_protocol_scope_service_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_unity_protocol_scope_service_dbus_interface_info), &_unity_protocol_scope_service_dbus_interface_vtable, data, _unity_protocol_scope_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_unity_protocol_scope_service_changed, data);
	return result;
}


static void _unity_protocol_scope_service_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_unity_protocol_scope_service_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



